/*
Marcin Owsiany 8:00
4 7.12.2000
4 18
*/
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include "fifo.h"

extern int errno;

void make_fifo(char *fname)
{
	if (mknod(fname, S_IFIFO | S_IRUSR | S_IWUSR, 0)) {
		if (errno != EEXIST) {
			perror("mknod()");
			exit(EXIT_FAILURE);
		}
	}
}

int client_fifo_init(char *fname)
{
	int n;
	make_fifo(fname);
	if (( n = open(fname, O_WRONLY)) == -1) {
		perror("open()");
		exit(EXIT_FAILURE);
	} else
		return n;
}

int server_fifo_init(char *fname)
{
	int n;
	make_fifo(fname);
	if (( n = open(fname, O_RDONLY)) == -1) {
		perror("open()");
		exit(EXIT_FAILURE);
	} else
		return n;
}

int fifo_msgsnd(int fd, struct my_msgbuf *msg, int n)
{
	return write(fd, msg, n);
}

int fifo_msgrecv(int fd, struct my_msgbuf *msg, int n)
{
	return read(fd, msg, n);
}


int fifo_close(int fd)
{
	return close(fd);
}
