/*
Marcin Owsiany 8:00
4 7.12.2000
12 18
*/

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include "msgq.h"

extern int errno;

int msgq_init(key_t key)
{
	int n;
	if (( n = msgget(key, IPC_CREAT | S_IREAD | S_IWRITE)) == -1) {
		perror("msgget()");
		exit(EXIT_FAILURE);
	} else
		return n;
}

int client_msgq_init(key_t key) { return msgq_init(key); }
int server_msgq_init(key_t key) { return msgq_init(key); }

int msgq_msgsnd(int id, struct my_msgbuf *msg, int n)
{
	if (msgsnd(id, msg, n, 0) != 0) {
		perror("msgsnd() failed");
		msgq_close(id);
		exit(EXIT_FAILURE);
	} else
		return n;
}

int msgq_msgrecv(int id, struct my_msgbuf *msg, int n)
{
	int k;
	if ((k = msgrcv(id, msg, n, msg->mtype, 0)) != n) {
		fprintf(stderr, "msgrcv for %d bytes got %d bytes", n, k);
		perror("msgrecv() failed");
		msgq_close(id);
		exit(EXIT_FAILURE);
	} else
		return n;
}

int msgq_close(int id)
{
	return msgctl(id, IPC_RMID, NULL);
}
